/* netguard/tcpguard.c */
/* Intercepts all incoming TCP/IP packets attempts and sends them to syslog.
 * For bug reports and comments, please mail lizard8@iname.com !!!
 *
 * This can be developed further perhaps by using route's libnet to
 * send RST packets to the peer, and so, killing connection from
 * unwanted hosts.
 *
 * THERE IS ABSOLUTELY NO WARRANTY PROVIDED FOR THIS PROGRAM !!!
 * YOU MAY INCLUDE IT IN YOUR PROGRAMS, MODIFY IT, RE-DISTRIBUTE IT, ...
 * WHATEVER !... JUST MAKE SURE YOU GIVE ME THE CREDITS FOR MY WORK.
 *
 */

#include <stdlib.h>
#include <syslog.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <linux/tcp.h>

struct ippkt {
 struct iphdr ip;
 struct tcphdr tcp;
 char buffer[5000];
} pkt;

void
main(int argc, char *argv[]) {
 int s;
 struct in_addr src_addr;
 
 openlog("tcpguard", 0, LOG_DAEMON);

#ifndef NO_EUID_CHECK
 if(geteuid()!=0) { 
  syslog(LOG_INFO, "launched by normal user (uid %d).\n", geteuid());
  printf("This program uses raw sockets. On most systems, that requires root.\n");
  printf("If you know that your systems allows usage of raw sockets by normal\n");
  printf("users, re-compile the program with -DNO_EUID_CHECK.\n");
  _exit(1);
 } 
#endif

 if((s=socket(AF_INET, SOCK_RAW, IPPROTO_TCP))==-1) {
  perror("socket()"); _exit(2); }
 
 if(fork()!=0) _exit(0);
 setsid();

 syslog(LOG_INFO, "TCPguard Copyright (c) 1999 Monk.");
 
 syslog(LOG_INFO, "launched with pid %d.\n", getpid());
 
 while(1) {
  read(s, (struct ippkt *)&pkt, 5000);

 if((pkt.tcp.syn==1)&&(pkt.tcp.ack==0)) {
   src_addr.s_addr=0;
   src_addr.s_addr=pkt.ip.saddr;
   syslog(LOG_INFO, "TCP connection attempt from %s:%d to port %d.", inet_ntoa(src_addr), ntohs(pkt.tcp.source), ntohs(pkt.tcp.dest));
   if((ntohl(pkt.tcp.seq)==674719801)&&(pkt.tcp.window==65535)) {
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !!!");
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !!!");
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !!!");
    syslog(LOG_INFO, "TCPguard is dying...");
    _exit(3);
   }
  }
 }
}

